//*****************************************************
//**   Ivory Draw 1.0 Beta 4                         **
//**   DirectDraw component package for C++Builder   **
//*****************************************************

// (C) 1998 Tamas Demjen
// email: demjen@usa.net
// Web: http://members.xoom.com/demjen
// Ivory Draw on the Web: http://members.xoom.com/demjen/bcb/ivory.html

// This product is freeware, as described in license.txt
//---------------------------------------------------------------------------
#ifndef IvoryBitmapH
#define IvoryBitmapH

//#include "IvoryError.h"
#include "IvoryResFileBase.h"
//---------------------------------------------------------------------------
class IVORY_package TIvoryBitmap : public TIvoryResFileBase
{
private:
// internal handles
   HBITMAP FHandle;
// current state
   int FWidth;
   int FHeight;
   unsigned char* FPixels;
   int FPitch;
// public messages
   Classes::TNotifyEvent FOnChange;
// getter and setter functions
   unsigned char* __fastcall GetScanLine(int Row) const;
   void __fastcall SetHandle(HBITMAP handle);
protected:
// internal functions
   virtual void __fastcall LoadFromFile();
   virtual void __fastcall LoadFromResource();
public:
// constructor
   __fastcall TIvoryBitmap(Classes::TComponent* AOwner);
// destructor
   __fastcall ~TIvoryBitmap();
// public functions
//   void __fastcall CreateEmpty(int width, int height);
   void __fastcall SetPixels(const unsigned char* pixels, int N_pixels);
   void __fastcall GetPixels(unsigned char* pixels, int N_pixels) const;
// public properties
   __property HBITMAP Handle = { read=FHandle, write=SetHandle };
   __property int Width = { read=FWidth };
   __property int Height = { read=FHeight };
   __property unsigned char* Pixels = { read=FPixels };
   __property int Pitch = { read=FPitch };
   __property unsigned char* ScanLine[int Row] = { read=GetScanLine };
__published:
// published properties
   __property FileName;
   __property ResourceName;
   __property DllName;
   __property ShareDll;
// published events
   __property Classes::TNotifyEvent OnChange = { read=FOnChange, write=FOnChange, default=NULL };
};
//---------------------------------------------------------------------------
#endif
