//*****************************************************
//**   Ivory Draw 1.0 Beta 4                         **
//**   DirectDraw component package for C++Builder   **
//*****************************************************

// (C) 1998 Tamas Demjen
// email: demjen@usa.net
// Web: http://members.xoom.com/demjen
// Ivory Draw on the Web: http://members.xoom.com/demjen/bcb/ivory.html

// This product is freeware, as described in license.txt
//---------------------------------------------------------------------------
#ifndef IvoryErrorH
#define IvoryErrorH

#include <ddraw.h>
//---------------------------------------------------------------------------
#if __BORLANDC__==0x520
#define __IvoryBCB1__
#define IVORY_package
#else
#define __IvoryBCB3__
#define IVORY_package PACKAGE
#endif

enum TIvoryErrorClass { iecUnknown, iecIvoryDraw, iecCustomIvorySurface,
   iecIvorySurface, iecIvoryBitmapSurface, iecIvoryCanvas, iecIvoryPalette,
   iecIvoryBitmap, iecUser };
enum TIvoryErrorReason { ierUnknown, ierDirectX, ierIvoryDrawNotCreated,
   ierIvorySurfaceNotCreated, ierIvoryPaletteNotCreated,
   ierIvoryPaletteNotAssigned, ierInvalidHandle, ierOther };

class EIvoryError : public Exception
{
private:
   TIvoryErrorClass FClass;
   String FFunction;
   TIvoryErrorReason FReason;
   HRESULT FDDResult;
protected:
   static String __fastcall GetDDErrorMsg(HRESULT result);
   static String __fastcall TIvoryErrorClassToString(TIvoryErrorClass eclass);
   static String __fastcall TIvoryErrorReasonToString(TIvoryErrorReason ereason);
   String __fastcall GetClassString() const { return TIvoryErrorClassToString(Class); }
   String __fastcall GetReasonString() const { return TIvoryErrorReasonToString(Reason); }
   String __fastcall GetDDResultString() const { return GetDDErrorMsg(DDResult); }
public:
   __fastcall EIvoryError(const String msg, TIvoryErrorClass eclass, const String function, TIvoryErrorReason ereason, HRESULT ddr = -1)
      : Exception(msg), FClass(eclass), FFunction(function), FReason(ereason), FDDResult(ddr) { }

   __property TIvoryErrorClass Class = { read=FClass };
   __property String ClassString = { read=GetClassString };
   __property String Function = { read=FFunction };
   __property TIvoryErrorReason Reason = { read=FReason };
   __property String ReasonString = { read=GetReasonString };
   __property HRESULT DDResult = { read=FDDResult };
   __property String DDResultString = { read=GetDDResultString };
};

#define IVORYERROR(msg, ereason) throw EIvoryError(msg, iec, ivoryfuncname, ereason)
#define IVORYDDERROR(msg, ereason, ddr) throw EIvoryError(msg, iec, ivoryfuncname, ereason, ddr)
//---------------------------------------------------------------------------
#endif
