//*****************************************************
//**   Ivory Draw 1.0 Beta 4                         **
//**   DirectDraw component package for C++Builder   **
//*****************************************************

// (C) 1998 Tamas Demjen
// email: demjen@usa.net
// Web: http://members.xoom.com/demjen
// Ivory Draw on the Web: http://members.xoom.com/demjen/bcb/ivory.html

// This product is freeware, as described in license.txt
//---------------------------------------------------------------------------
#ifndef IvoryPaletteH
#define IvoryPaletteH

//#include "IvoryError.h"
#include "IvoryResFileBase.h"
//---------------------------------------------------------------------------
class IVORY_package TIvoryDraw;
class IVORY_package TCustomIvorySurface;

class IVORY_package TIvoryPalette : public TIvoryResFileBase
{
   friend TIvoryDraw;
   friend TCustomIvorySurface;
private:
// internal handles
   LPDIRECTDRAWPALETTE FDirectDrawPalette;
   HPALETTE hPalette;
// current state
   TColor FColors[256];
   TColor FOriginal0;
   TColor FOriginal255;
   bool FUpdate;
// public messages
   Classes::TNotifyEvent FOnChange;
// getter and setter functions
   TColor __fastcall GetColor(int n) const;
   void __fastcall SetColor(int n, TColor c);
   TColor __fastcall GetOriginalColor(int n) const;
protected:
// internal functions
   void __fastcall Release();
   void __fastcall UpdateAllColors();
   void __fastcall FastLoadFromBMP(unsigned char* Memory, int offsetpal, int sizepal);
   void __fastcall FastLoadFromPCX(unsigned char* Memory, int offsetpal, int sizepal);
   virtual void __fastcall LoadFromFile();
   virtual void __fastcall LoadFromResource();
public:
// constructor
   __fastcall TIvoryPalette(TComponent* AOwner);
// destructor
   virtual __fastcall ~TIvoryPalette();
// public functions
   void __fastcall Create();
   void __fastcall BeginUpdate();
   void __fastcall EndUpdate();
   inline const TColor* __fastcall GetColors() const { return FColors; }
   void __fastcall SetColors(TColor* c);
   inline TColor __fastcall GetNearestColor(TColor c) { return Color[GetNearestPaletteIndex(c)]; }
   int __fastcall GetNearestPaletteIndex(TColor c);
// public properties
   __property LPDIRECTDRAWPALETTE DirectDrawPalette = { read=FDirectDrawPalette };
   __property TColor Color[int n] = { read=GetColor, write=SetColor };
   __property TColor OriginalColor[int n] = { read=GetOriginalColor };
__published:
// published properties
   __property FileName;
   __property ResourceName;
   __property DllName;
   __property ShareDll;
// published events
   __property Classes::TNotifyEvent OnChange = { read=FOnChange, write=FOnChange, default=NULL };
};
//---------------------------------------------------------------------------
#endif
