//*****************************************************
//**   Ivory Draw 1.0 Beta 4                         **
//**   DirectDraw component package for C++Builder   **
//*****************************************************

// (C) 1998 Tamas Demjen
// email: demjen@usa.net
// Web: http://members.xoom.com/demjen
// Ivory Draw on the Web: http://members.xoom.com/demjen/bcb/ivory.html

// This product is freeware, as described in license.txt
//---------------------------------------------------------------------------
#ifndef IvoryResFileBaseH
#define IvoryResFileBaseH

#include "IvoryError.h"
//---------------------------------------------------------------------------
class IVORY_package TIvoryResFileBase: public TComponent
{
private:
// internal handles
   HANDLE FDllHandle;
// current state
   String FFileName;
   String FResourceName;
   String FDllName;
   bool FDllLoaded;
   bool FShareDll;
// getter and setter functions
   void __fastcall SetHandle(HBITMAP handle);
   void __fastcall SetFileName(const String filename);
   void __fastcall SetResourceName(const String resname);
   void __fastcall SetDllHandle(HANDLE dllhandle);
   void __fastcall SetDllName(const String dllname);
protected:
   virtual void __fastcall LoadFromFile();
   virtual void __fastcall LoadFromResource();
public:
// constructor
   __fastcall TIvoryResFileBase(TComponent* AOwner);
// destructor
   virtual __fastcall ~TIvoryResFileBase();
// public functions
   inline void __fastcall LoadFromFile(const String filename) { FileName = filename; }
   inline void __fastcall LoadFromDll(const String resname, const String dllname) { DllName = dllname; ResourceName = resname; }
   inline void __fastcall LoadFromDll(int resid, const String dllname) { DllName = dllname; ResourceName = "#" + IntToStr(resid); }
   inline void __fastcall LoadFromResourceName(int instance, const String resname) { DllHandle = (HANDLE)instance; ResourceName = resname; }
   inline void __fastcall LoadFromResourceId(int instance, int resid) { DllHandle = (HANDLE)instance; ResourceName = "#" + IntToStr(resid); }
// public properties
   __property HANDLE DllHandle = { read=FDllHandle, write=SetDllHandle };
   __property bool DllLoaded = { read=FDllLoaded };
// gonna be published properties in descendants
   __property String FileName = { read=FFileName, write=SetFileName };
   __property String ResourceName = { read=FResourceName, write=SetResourceName };
   __property String DllName = { read=FDllName, write=SetDllName };
   __property bool ShareDll = { read=FShareDll, write=FShareDll, default=false };
};
//---------------------------------------------------------------------------
#endif
